package fr.soleil.docking.vl;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.util.ArrayList;
import java.util.List;

import javax.swing.Icon;

import com.vldocking.swing.docking.DockKey;

import fr.soleil.docking.view.IView;
import fr.soleil.docking.view.IViewListener;

public class VlDockView  implements IView {
	  protected Object id;
	    protected boolean enabled;
	    protected boolean visible;
	    protected String title;
	    protected Component component;
	    protected Icon icon;
	    protected DockKey key;
	    protected VlDockDockingManager manager;

	    public VlDockView(String title, Icon icon, Component component, Object id, VlDockDockingManager manager) {
	        this.title = title;
	        this.icon = icon;
	        this.component = component;
	        this.id = id;
	        this.key = new DockKey(title, title, title, icon);
	        this.key.setFloatEnabled(false);
	        this.manager = manager;
	    }

	    @Override
	    public Component getComponent() {
	        return component;
	    }

	    @Override
	    public Object getId() {
	        return id;
	    }

	    @Override
	    public boolean isEnabled() {
	        return enabled;
	    }

	    @Override
	    public void setEnabled(boolean enabled) {
	        this.enabled = enabled;
	    }

	    @Override
	    public boolean isVisible() {
	        return visible;
	    }

	    @Override
	    public void setVisible(boolean visible) {
	        this.visible = visible;

	    }

	    @Override
	    public String getTitle() {
	        return title;
	    }

	    @Override
	    public Icon getIcon() {
	        return icon;
	    }

	    @Override
	    public Color getViewBackground() {
	        return component.getBackground();
	    }

	    @Override
	    public void setViewBackground(Color bg) {
	        if (component instanceof Container) {
	            List<Component> components = getAllComponents((Container) component);
	            setComponentsBackground(components, bg);
	        }
	        component.setBackground(bg);
	    }

	    @Override
	    public Color getViewForeground() {
	        return component.getForeground();
	    }

	    @Override
	    public void setViewForeground(Color fg) {
	        component.setForeground(fg);
	    }

	    /*
	     * Sets the background of all {@link Component}s in a given {@link List}
	     * 
	     * @param components The {@link List}
	     * @param bg The background to set
	     */
	    protected void setComponentsBackground(List<?> components, Color bg) {
	        if (components != null) {
	            for (Object comp : components) {
	                if (comp instanceof Component) {
	                    ((Component) comp).setBackground(bg);
	                }
	            }
	        }
	    }

	    /**
	     * Sets the foreground of all {@link Component}s in a given {@link List}
	     * 
	     * @param components The {@link List}
	     * @param bg The foreground to set
	     */
	    protected void setComponentsForeground(List<?> components, Color bg) {
	        if (components != null) {
	            for (Object comp : components) {
	                if (comp instanceof Component) {
	                    ((Component) comp).setForeground(bg);
	                }
	            }
	        }
	    }

	    public List<Component> getAllComponents(final Container c) {
	        Component[] comps = c.getComponents();
	        List<Component> compList = new ArrayList<Component>();
	        for (Component comp : comps) {
	            compList.add(comp);
	            if (comp instanceof Container) {
	                compList.addAll(getAllComponents((Container) comp));
	            }
	        }
	        return compList;
	    }

	    @Override
	    public void setClosable(boolean closable) {
	        // TODO Auto-generated method stub

	    }

	    @Override
	    public void addViewListener(IViewListener listener) {
	        // TODO Auto-generated method stub

	    }
}
